diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/keymap.c tin-2.6.5/src/keymap.c
--- tin-2.6.4/src/keymap.c	2024-12-05 01:54:16.000000000 +0100
+++ tin-2.6.5/src/keymap.c	2025-11-13 02:21:32.440173886 +0100
@@ -3,10 +3,10 @@
  *  Module    : keymap.c
  *  Author    : D. Nimmich, J. Faultless
  *  Created   : 2000-05-25
- *  Updated   : 2024-12-05
+ *  Updated   : 2025-11-07
  *  Notes     : This file contains key mapping routines and variables.
  *
- * Copyright (c) 2000-2025 Dirk Nimmich <nimmich@muenster.de>
+ * Copyright (c) 2000-2026 Dirk Nimmich <nimmich@muenster.de>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -337,7 +337,7 @@ read_keymap_file(
 	char *territory = NULL;
 	char *codeset = NULL, *normcodeset = NULL;
 	char *modifier = NULL;
-	char *fnames[2 * 6] = { NULL }; /* 2 dirs x 6 variants */
+	char *fnames[2 * 10] = { NULL }; /* 2 dirs x 10 variants */
 	char dirs[3][PATH_LEN]; /* 2 dirs + endmark */
 	char buf[LEN];
 	int k = 0, j, i = 0, n;
@@ -347,19 +347,14 @@ read_keymap_file(
 
 	/*
 	 * checks ${TIN_HOMEDIR:-"$HOME"}, TIN_DEFAULTS_DIR
-	 * for KEYMAP_FILE."locale" or KEYMAP_FILE
+	 * for KEYMAP_FILE[."locale"] where
 	 *
 	 * locale is first match from LC_ALL, LC_MESSAGES, LC_CTYPE, LANG
 	 *
-	 * language[_territory[.codeset]][@modifier]
+	 * language[_territory][.codeset][@modifier]
 	 * Beside the first part, all of them are allowed to be missing. If the
 	 * full specified locale is not found, less specific ones are looked
-	 * for. The various parts will be stripped off, in the following
-	 * order:
-	 * - codeset
-	 * - normalized codeset (like _nl_normalize_codeset() in glibc)
-	 * - territory
-	 * - modifier
+	 * for.
 	 */
 
 	sprintf(dirs[k++], "%s", rcdir);
@@ -445,6 +440,38 @@ read_keymap_file(
 						++i;
 				}
 			}
+			if (codeset && territory) { /* explicitly leave out set territory */
+				if ((n = snprintf(NULL, 0, "%s/%s.%s%s%s", dirs[k], KEYMAP_FILE, BlankIfNull(language), codeset, BlankIfNull(modifier))) > 0) {
+					s = (size_t) n + 1;
+					fnames[i] = my_malloc(s);
+					if (snprintf(fnames[i], s, "%s/%s.%s%s%s", dirs[k], KEYMAP_FILE, BlankIfNull(language), codeset, BlankIfNull(modifier)) == n)
+						++i;
+				}
+			}
+			if (normcodeset && territory) { /* explicitly leave out set territory */
+				if ((n = snprintf(NULL, 0, "%s/%s.%s%s%s", dirs[k], KEYMAP_FILE, BlankIfNull(language), normcodeset, BlankIfNull(modifier))) > 0) {
+					s = (size_t) n + 1;
+					fnames[i] = my_malloc(s);
+					if (snprintf(fnames[i], s, "%s/%s.%s%s%s", dirs[k], KEYMAP_FILE, BlankIfNull(language), normcodeset, BlankIfNull(modifier)) == n)
+						++i;
+				}
+			}
+			if (codeset && territory && modifier) { /* explicitly leave out set territory and modifier */
+				if ((n = snprintf(NULL, 0, "%s/%s.%s%s", dirs[k], KEYMAP_FILE, BlankIfNull(language), codeset)) > 0) {
+					s = (size_t) n + 1;
+					fnames[i] = my_malloc(s);
+					if (snprintf(fnames[i], s, "%s/%s.%s%s", dirs[k], KEYMAP_FILE, BlankIfNull(language), codeset) == n)
+						++i;
+				}
+			}
+			if (normcodeset && territory && modifier) { /* explicitly leave out set territory and modifier */
+				if ((n = snprintf(NULL, 0, "%s/%s.%s%s", dirs[k], KEYMAP_FILE, BlankIfNull(language), normcodeset)) > 0) {
+					s = (size_t) n + 1;
+					fnames[i] = my_malloc(s);
+					if (snprintf(fnames[i], s, "%s/%s.%s%s", dirs[k], KEYMAP_FILE, BlankIfNull(language), normcodeset) == n)
+						++i;
+				}
+			}
 			if (territory) {
 				if ((n = snprintf(NULL, 0, "%s/%s.%s%s%s", dirs[k], KEYMAP_FILE, BlankIfNull(language), territory, BlankIfNull(modifier))) > 0) {
 					s = (size_t) n + 1;
@@ -541,7 +568,7 @@ read_keymap_file(
 			/*
 			 * Warn about basic syntax errors
 			 */
-			if (keydef == NULL || !strlen(keydef)) {
+			if (keydef == NULL || !*keydef) {
 				error_message(0, _(txt_keymap_missing_key), kname);
 				ret = FALSE;
 				continue;
@@ -610,12 +637,13 @@ process_keys(
 		 * ^A -> control chars
 		 * TAB -> ^I
 		 * SPACE -> ' '
+		 * NULL -> \0
 		 */
 #if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
-		if (wcslen(wkeydef) > 1) {
+		if (wcslen(wkeydef) > 1)
 			switch (wkeydef[0])	/* Only test 1st char - crude but effective */
 #else
-		if (strlen(keydef) > 1) {
+		if (strlen(keydef) > 1)
 			switch (keydef[0])	/* Only test 1st char - crude but effective */
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 			{
@@ -651,7 +679,7 @@ process_keys(
 					error = TRUE;
 					break;
 			}
-		} else {
+		else {
 #if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
 			if (iswdigit((wint_t) (key = wkeydef[0])))
 #else
@@ -785,13 +813,20 @@ process_mapping(
 
 				return TRUE;
 			}
+			if (STRCMPEQ(keyname, "ConfigServerrcMenu")) {
+				process_keys(CONFIG_SERVERRC_MENU, keys, &option_menu_keys);
+
+				return TRUE;
+			}
 			if (STRCMPEQ(keyname, "ConfigToggleAttrib")) {
 				process_keys(CONFIG_TOGGLE_ATTRIB, keys, &option_menu_keys);
 
 				return TRUE;
 			}
 			if (STRCMPEQ(keyname, "ConnectionInfo")) {
+				process_keys(GLOBAL_CONNECTION_INFO, keys, &attachment_keys);
 				process_keys(GLOBAL_CONNECTION_INFO, keys, &group_keys);
+				process_keys(GLOBAL_CONNECTION_INFO, keys, &option_menu_keys);
 				process_keys(GLOBAL_CONNECTION_INFO, keys, &page_keys);
 				process_keys(GLOBAL_CONNECTION_INFO, keys, &select_keys);
 				process_keys(GLOBAL_CONNECTION_INFO, keys, &thread_keys);
@@ -1112,6 +1147,12 @@ process_mapping(
 			break;
 
 		case 'M':
+			if (STRCMPEQ(keyname, "MarkAncientArtRead")) {
+				process_keys(MARK_ANCIENT_ART_READ, keys, &group_keys);
+				process_keys(MARK_ANCIENT_ART_READ, keys, &select_keys);
+
+				return TRUE;
+			}
 			if (STRCMPEQ(keyname, "MarkArticleUnread")) {
 				process_keys(MARK_ARTICLE_UNREAD, keys, &group_keys);
 				process_keys(MARK_ARTICLE_UNREAD, keys, &page_keys);
@@ -1152,6 +1193,7 @@ process_mapping(
 
 				return TRUE;
 			}
+
 			break;
 
 		case 'O':
@@ -1349,6 +1391,11 @@ process_mapping(
 
 				return TRUE;
 			}
+			if (STRCMPEQ(keyname, "PageToggleInlineData")) {
+				process_keys(PAGE_TOGGLE_INLINE_DATA, keys, &page_keys);
+
+				return TRUE;
+			}
 			if (STRCMPEQ(keyname, "PageToggleRaw")) {
 				process_keys(PAGE_TOGGLE_RAW, keys, &page_keys);
 
@@ -1369,8 +1416,8 @@ process_mapping(
 
 				return TRUE;
 			}
-			if (STRCMPEQ(keyname, "PageToggleUue")) {
-				process_keys(PAGE_TOGGLE_UUE, keys, &page_keys);
+			if (STRCMPEQ(keyname, "PageToggleVerbatim")) {
+				process_keys(PAGE_TOGGLE_VERBATIM, keys, &page_keys);
 
 				return TRUE;
 			}
@@ -2000,6 +2047,7 @@ process_mapping(
 			if (STRCMPEQ(keyname, "ToggleInfoLastLine")) {
 				process_keys(GLOBAL_TOGGLE_INFO_LAST_LINE, keys, &attachment_keys);
 				process_keys(GLOBAL_TOGGLE_INFO_LAST_LINE, keys, &group_keys);
+				process_keys(GLOBAL_TOGGLE_INFO_LAST_LINE, keys, &option_menu_keys);
 				process_keys(GLOBAL_TOGGLE_INFO_LAST_LINE, keys, &page_keys);
 				process_keys(GLOBAL_TOGGLE_INFO_LAST_LINE, keys, &select_keys);
 				process_keys(GLOBAL_TOGGLE_INFO_LAST_LINE, keys, &thread_keys);
@@ -2422,6 +2470,8 @@ upgrade_keymap_file(
 					catchup_next_unread[1] = my_strdup(keydef);
 				else if (STRCMPEQ(keyname, "PageToggleHeaders"))
 					fprintf(newfp, "PageToggleRaw\t\t\t%s\n", keydef);
+				else if (STRCMPEQ(keyname, "PageToggleUue"))
+					fprintf(newfp, "PageToggleInlineData\t%s\n", keydef);
 				else if (STRCMPEQ(keyname, "PromptNo") || STRCMPEQ(keyname, "PromptYes")) {
 					if (strlen(keydef) == 1 && islower((unsigned char) keydef[0]))
 						fprintf(newfp, "%s\t\t\t%c\t%c\n", keyname, keydef[0], my_toupper((unsigned char) keydef[0]));
@@ -2732,6 +2782,7 @@ setup_default_keys(
 	add_default_key(&attachment_keys, "g^", GLOBAL_FIRST_PAGE);
 	add_default_key(&attachment_keys, "G$", GLOBAL_LAST_PAGE);
 	add_default_key(&attachment_keys, "i", GLOBAL_TOGGLE_INFO_LAST_LINE);
+	add_default_key(&attachment_keys, "J", GLOBAL_CONNECTION_INFO);
 	add_default_key(&attachment_keys, "p", ATTACHMENT_PIPE);
 	add_default_key(&attachment_keys, "q", GLOBAL_QUIT);
 	add_default_key(&attachment_keys, "s", ATTACHMENT_SAVE);
@@ -2785,6 +2836,7 @@ setup_default_keys(
 	/* select level */
 	add_global_keys(&select_keys);
 	add_default_key(&select_keys, "\n\r", SELECT_ENTER_GROUP);
+	add_default_key(&select_keys, "", MARK_ANCIENT_ART_READ);
 	add_default_key(&select_keys, "", SELECT_RESET_NEWSRC);
 	add_default_key(&select_keys, "c", CATCHUP);
 	add_default_key(&select_keys, "d", SELECT_TOGGLE_DESCRIPTIONS);
@@ -2816,6 +2868,7 @@ setup_default_keys(
 	add_global_keys(&group_keys);
 	add_default_key(&group_keys, "", GLOBAL_MENU_FILTER_SELECT);
 	add_default_key(&group_keys, "\n\r", GROUP_READ_BASENOTE);
+	add_default_key(&group_keys, "", MARK_ANCIENT_ART_READ);
 	add_default_key(&group_keys, "", GLOBAL_MENU_FILTER_KILL);
 	add_default_key(&group_keys, "", MARK_FEED_READ);
 	add_default_key(&group_keys, "", MARK_FEED_UNREAD);
@@ -2962,7 +3015,7 @@ setup_default_keys(
 	add_default_key(&page_keys, "<", PAGE_TOP_THREAD);
 	add_default_key(&page_keys, ">", PAGE_BOTTOM_THREAD);
 	add_default_key(&page_keys, "\"", PAGE_TOGGLE_TEX2ISO);
-	add_default_key(&page_keys, "(", PAGE_TOGGLE_UUE);
+	add_default_key(&page_keys, "(", PAGE_TOGGLE_INLINE_DATA);
 	add_default_key(&page_keys, ")", PAGE_REVEAL);
 	add_default_key(&page_keys, "[", GLOBAL_QUICK_FILTER_SELECT);
 	add_default_key(&page_keys, "]", GLOBAL_QUICK_FILTER_KILL);
@@ -2970,6 +3023,7 @@ setup_default_keys(
 	add_default_key(&page_keys, "*", PAGE_TOGGLE_HEADERS);
 	add_default_key(&page_keys, ":", PAGE_SKIP_INCLUDED_TEXT);
 	add_default_key(&page_keys, "_", PAGE_TOGGLE_HIGHLIGHTING);
+	add_default_key(&page_keys, ",", PAGE_TOGGLE_VERBATIM);
 	add_default_key(&page_keys, "'", PAGE_ARTICLE_INFO);
 
 	/* info pager */
@@ -3006,10 +3060,12 @@ setup_default_keys(
 	add_default_key(&option_menu_keys, "g^", GLOBAL_FIRST_PAGE);
 	add_default_key(&option_menu_keys, "G$", GLOBAL_LAST_PAGE);
 	add_default_key(&option_menu_keys, "h", GLOBAL_HELP);
+	add_default_key(&option_menu_keys, "J", GLOBAL_CONNECTION_INFO);
 	add_default_key(&option_menu_keys, "q", GLOBAL_QUIT);
 	add_default_key(&option_menu_keys, "r", CONFIG_RESET_ATTRIB);
 	add_default_key(&option_menu_keys, "v", GLOBAL_VERSION);
 	add_default_key(&option_menu_keys, "Q", CONFIG_NO_SAVE);
+	add_default_key(&option_menu_keys, "s", CONFIG_SERVERRC_MENU);
 	add_default_key(&option_menu_keys, "S", CONFIG_SCOPE_MENU);
 	add_default_key(&option_menu_keys, ">", GLOBAL_SCROLL_DOWN);
 	add_default_key(&option_menu_keys, "<", GLOBAL_SCROLL_UP);
@@ -3274,7 +3330,7 @@ add_global_keys(
  * and pipe generated file through something like
  * 	sort|uniq|\
  * 	awk '/^[^#]/{a[$1]=a[$1]"\t"$2}END{for(x in a){print x"\t"a[x]}}'|sort
- * inspection
+ * for inspection
  */
 #ifdef DEBUG
 static void dump_keylist(const struct keylist keys);
@@ -3311,6 +3367,7 @@ dump_keylist(
 		"ConfigResetAttrib",
 		"ConfigScopeMenu",
 		"ConfigSelect",
+		"ConfigServerrcMenu",
 		"ConfigNoSave",
 		"ConfigToggleAttrib",
 		"FeedArt",
@@ -3399,6 +3456,7 @@ dump_keylist(
 		"GroupToggleThreading",
 		"GroupUndoSel",
 		"GroupUntag",
+		"MarkAncientArtRead",
 		"MarkArticleUnread",
 		"MarkThreadUnread",
 		"MarkFeedRead",
@@ -3435,11 +3493,12 @@ dump_keylist(
 		"PageTag",
 		"PageToggleAllHeaders",
 		"PageToggleHighlight",
+		"PageToggleInlineData",
 		"PageToggleRaw",
 		"PageToggleRot",
 		"PageToggleTabs",
 		"PageToggleTex2iso",
-		"PageToggleUue",
+		"PageToggleVerbatim",
 		"PageTopThd",
 		"PageViewAttach",
 		"PageViewUrl",
@@ -3528,8 +3587,7 @@ dump_keylist(
 
 static void
 dump_all_keys(
-	void
-)
+	void)
 {
 	if (debug) { /* order? */
 		dump_keylist(attachment_keys);
